<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for squashtypes.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
squashtypes - collapse heirarchies of group types

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>squashtypes</B> <I>infile</I> <I>outfile</I> { <I>infile</I> <I>outfile</I> } *

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>squashtypes</I> program collapses heirarchies of group
types. Each such heirarcy is replaced with a single group
type, under which are all the leaf fields of all the
groups at the appropriate absolute offsets. This can be
useful for making the code more readable and to help backend
C compilers -- some have trouble with very long
heirarchies of group types that get turned into long
heirarchies of structures. Such heirarchies can be created
by various code transformations. For example,
padding between globals can be done by pairwise joining
globals into a new group type with two fields, and repeating
this for many globals leads to a deep heirarchy.

<H2><A NAME="sect3" HREF="#toc3"><B>History</B></A></H2>

<P>
This program was written by Chris Wilson.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">History</A></LI>
</UL>
</BODY></HTML>
